package poi.test.code;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Comment {

	private Comment() {

	}

	public static Node getCommentsDocument(Document document) {
		Element comments = document
				.createElement(CommentConstants.ELEMENT_COMMENTS);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WPC,
				CommentConstants.ATTRIBUTE_XMLNS_WPC_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_MC,
				CommentConstants.ATTRIBUTE_XMLNS_MC_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_O,
				CommentConstants.ATTRIBUTE_XMLNS_O_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_R,
				CommentConstants.ATTRIBUTE_XMLNS_R_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_M,
				CommentConstants.ATTRIBUTE_XMLNS_M_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_V,
				CommentConstants.ATTRIBUTE_XMLNS_V_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WP14,
				CommentConstants.ATTRIBUTE_XMLNS_WP14_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WP,
				CommentConstants.ATTRIBUTE_XMLNS_WP_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_W10,
				CommentConstants.ATTRIBUTE_XMLNS_W10_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_W,
				CommentConstants.ATTRIBUTE_XMLNS_W_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_W14,
				CommentConstants.ATTRIBUTE_XMLNS_W14_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WPG,
				CommentConstants.ATTRIBUTE_XMLNS_WPG_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WPI,
				CommentConstants.ATTRIBUTE_XMLNS_WPI_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WNE,
				CommentConstants.ATTRIBUTE_XMLNS_WNE_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_XMLNS_WPS,
				CommentConstants.ATTRIBUTE_XMLNS_WPS_VAL);
		comments.setAttribute(CommentConstants.ATTRIBUTE_MC_IGNORABLE,
				CommentConstants.ATTRIBUTE_MC_IGNORABLE_VAL);

		return comments;
	}

	public static Node getCommentStartNode(Document document, int id) {

		Element commentStart = document
				.createElement(CommentConstants.ELEMENT_COMMENT_RANGE_START);
		commentStart.setAttribute(CommentConstants.ATTRIBUTE_ID,
				Integer.toString(id));

		return commentStart;
	}

	public static Node getCommentEndNode(Document document, int id) {
		Element commentEnd = document
				.createElement(CommentConstants.ELEMENT_COMMENT_RANGE_END);
		commentEnd.setAttribute(CommentConstants.ATTRIBUTE_ID,
				Integer.toString(id));

		return commentEnd;

	}

	public static Node getCommentReferenceNode(Document document, int id) {
		Element commentRun = document
				.createElement(WordXMLConstants.ELEMENT_W12_RUN);
		Element commentRpR = document
				.createElement(WordXMLConstants.ELEMENT_W12_RUN_PROPERTIES);
		Element commentStyle = document
				.createElement(WordXMLConstants.ELEMENT_W12_RUN_STYLE);
		Element commentRef = document
				.createElement(CommentConstants.ELEMENT_COMMENT_REFERENCE);
		commentStyle.setAttribute(WordXMLConstants.ATTRIBUTE_VAL,
				CommentConstants.ATTRIBUTE_COMMENT_RUN_STYLE_VAL);
		commentRef.setAttribute(CommentConstants.ATTRIBUTE_ID,
				Integer.toString(id));
		commentRpR.appendChild(commentStyle);
		commentRun.appendChild(commentRpR);
		commentRun.appendChild(commentRef);

		return commentRun;
	}

	public static Node getCommentWithID(Document document, int id,
			WordFinding woTag) {
		Element comment = document
				.createElement(CommentConstants.ELEMENT_COMMENT);
		if (woTag.getAuthor() != null) {
			comment.setAttribute(WordXMLConstants.ATTRIBUTE_AUTHOR,
					woTag.getAuthor());
		}
		if (woTag.getInitials() != null) {
			comment.setAttribute(WordXMLConstants.ATTRIBUTE_INITIALS,
					woTag.getInitials());
		}
		comment.setAttribute(CommentConstants.ATTRIBUTE_ID, Integer.toString(id));

		Element commentParagraph = document
				.createElement(WordXMLConstants.ELEMENT_W12_PARAGRAPH);
		Element commentpPr = document
				.createElement(WordXMLConstants.ELEMENT_W12_PARAGRAPH_PROPERTIES);
		Element commentParagraphStyle = document
				.createElement(WordXMLConstants.ELEMENT_W12_PARAGRAPH_STYLE);
		commentParagraphStyle.setAttribute(WordXMLConstants.ATTRIBUTE_VAL,
				CommentConstants.ATTRIBUTE_COMMENT_PARAGRAPH_STYLE_VAL);
		Element commentRun1Style = document
				.createElement(WordXMLConstants.ELEMENT_W12_RUN);
		Element commentRunPr = document
				.createElement(WordXMLConstants.ELEMENT_W12_RUN_PROPERTIES);
		Element commentRunStyle = document
				.createElement(WordXMLConstants.ELEMENT_W12_RUN_STYLE);
		commentRunStyle.setAttribute(WordXMLConstants.ATTRIBUTE_VAL,
				CommentConstants.ATTRIBUTE_COMMENT_RUN_STYLE_VAL);
		Element commentAnnotationRef = document
				.createElement(WordXMLConstants.ELEMENT_W12_ANNOTATION_REF);
		Element commentRun2Text = document.createElement(WordXMLConstants.ELEMENT_W12_RUN);
		Element commentText = document.createElement(WordXMLConstants.ELEMENT_W12_TEXT);
		commentText.setTextContent(woTag.getText());
		
		
		// add the paragraph to the comment w:p
		comment.appendChild(commentParagraph);
		// add the paragraph properties to the paragraph w:pPr
		commentParagraph.appendChild(commentpPr);
		// add the paragraph style to the paragraph properties w:pStyle
		commentpPr.appendChild(commentParagraphStyle);
		// add the run with the style to the paragraph w:r 
		commentParagraph.appendChild(commentRun1Style);
		// add the style to the run w:rStyle
		commentRunPr.appendChild(commentRunStyle);
		commentRun1Style.appendChild(commentRunPr);
		// add the annotation ref to the run w:annotationRef
		commentRun1Style.appendChild(commentAnnotationRef);
	
		// add the run with the text to the paragraph
		// add the text to the text run
		commentRun2Text.appendChild(commentText);
		commentParagraph.appendChild(commentRun2Text);

		return comment;
	}
}
