package poi.test.code;

public abstract class Finding implements Comparable<Finding> {
	
	protected String ADTType;
	protected String rulename;
	protected String text;
	protected String path;
	protected String tagPos;
	protected String markOptions;
	

	public Finding(String ADTType, String rulename,String text,String path,String tagPos) {
		this.ADTType = ADTType;
		this.rulename = rulename;
		this.text = text;
		this.path = path;
		this.tagPos = tagPos;	
		
		parsePosition();
		
		// TODO read properties how to mark the finding
		//readProperty();
		markOptions = "comment";
		
		readConfig();
	}
	
	public String getADTType() {
		return ADTType;
	}

	public void setADTType(String aDTType) {
		ADTType = aDTType;
	}
	
	public String getText() {
		return text;
	}
	public void setText(String text) {
		this.text = text;
	}
	public String getPath() {
		return path;
	}
	
	public void setPath(String path) {
		this.path = path;
	}
	public String getRulename() {
		return rulename;
	}
	public void setRulename(String rulename) {
		this.rulename = rulename;
	}
	public String getTagPos() {
		return tagPos;
	}

	public void setTagPos(String tagPos) {
		this.tagPos = tagPos;
	}
	
	public String getMarkOption() {
		return markOptions;
	}

	@Override
	public int compareTo(Finding o) {
		return path.compareToIgnoreCase(o.getPath());
	}
	
	@Override
	public String toString(){
		return "Tag: \"" + path + "\" Rule: " +  rulename + " on Type: " + ADTType+ ". mark position: " + tagPos;
	}
	
	/**
	 * Parse the position to the format depending on the document
	 */
	protected abstract void parsePosition();
		
	/**
	 * read the config for the tag
	 * assume docx only
	 */
	private void readConfig(){
		
	}
}
